]> rtime.felk.cvut.cz Git - can-benchmark.git/blobdiff - gw-tests/lib.sh
filter-sff: Test also the last id (2047)
[can-benchmark.git] / gw-tests / lib.sh
index f270c788847f636f86c9407a95f034e6c9f03778..79899c4ed150744c1c0ce4dbd1815311d9eaa33d 100644 (file)
@@ -29,27 +29,23 @@ sshgw() {
     ssh -x -a -S $socket root@192.168.2.3 "$@"
 }
 
-_cleanupgw() {
-    # Set can interfaces up
-    sshgw 'for i in 0 1; do ip link show dev can$i|grep -q UP || ip link set can$i up type can bitrate 1000000; done'
-    # Delete all GW rules
-    sshgw 'eval $(cangw -L|sed -e s/-A/-D/ -e "s/#.*/;/")'
+cleanupgw() {
+    sshgw 'cangw -F'
 }
 
 _plot() {
     local testname=`basename $0 .sh`
 
-    cmd=$(plot_cmds)                   # Get plot commands
-    cmd=$(echo "$cmd" | sed -e "/set title/ s/[\"']\(.*\)[\"']/\"\1\\\\n($kvers)\"/")
+    plot_cmds | sed -e "/set title/ s/[\"']\(.*\)[\"']/\"\1\\\\n($kvers)\"/" > plot.gp
     if [ -z "$OPT_NO_X11" ]; then
-       echo "set terminal x11 enhanced; ${cmd}" | gnuplot -persist
+       echo "set terminal x11 enhanced; $(< plot.gp)" | gnuplot -persist
     fi
     I=''
     echo 'set terminal postscript color eps enhanced size 6cm,4cm lw 1 "Times-Roman" 10;' \
        'set lmargin 8;' \
-       "${cmd}" | gnuplot > ${testname}$I.eps
+       "$(< plot.gp)" | gnuplot > ${testname}$I.eps
     echo "set terminal postscript color eps enhanced;" \
-       "${cmd}" | gnuplot | epstopdf --filter > ${testname}$I.pdf
+       "$(< plot.gp)" | gnuplot | epstopdf --filter > ${testname}$I.pdf
     mkdir -p thumb
     convert -density 30  -gamma 0.5 -quality 90 -type Palette -depth 8 ${testname}$I.pdf thumb/${testname}$I.png
     convert -density 150 -gamma 0.7 -quality 90 -type Palette -depth 8 ${testname}$I.pdf ${testname}$I.png
@@ -67,28 +63,64 @@ create_dirs_and_links() {
     echo $d
 }
 
+echo_plot() {
+    plot=$1
+    [[ "$_plot_separator" ]] && echo ", \\"
+    _plot_separator=t
+    echo -n "    " $plot
+}
+
 _run() {
-    _cleanupgw
-    kvers=$(sshgw uname -r)
-    dir=$(create_dirs_and_links $(basename $0 .sh) $kvers)
-    cd $dir
     if [[ ! "$OPT_PLOT_ONLY" ]]; then
-       main
+       kernel_versions=$(sshgw uname -r)
+    else
+       kernel_versions=$(ls results/by-kern)
     fi
-    _plot
+    for kvers in $kernel_versions; do
+       dir=$(create_dirs_and_links $(basename $0 .sh) $kvers)
+       script=$PWD/$0
+       cd $dir
+       echo "Working directory: $dir"
+       if [[ ! "$OPT_PLOT_ONLY" ]]; then
+           # Remove data from the last measurement
+           rm -rf *
+            # Set can interfaces up
+           sshgw 'for i in 0 1; do ip link show dev can$i|grep -q UP || ip link set can$i up type can bitrate 1000000; done'
+            # Delete all vcan interfaces
+           sshgw 'for dev in $(ip l|grep -o vcan[^:]\\+); do ip link del dev $dev; done'
+           # Reset priorities
+           sshgw 'chrt -p -f 50 `pidof irq/145-can0` > /dev/null'
+           sshgw 'chrt -p -f 50 `pidof irq/146-can1` > /dev/null'
+           sshgw 'chrt -p -f 49 `pidof sirq-net-rx/0` > /dev/null'
+           sshgw 'chrt -p -f 49 `pidof sirq-net-tx/0` > /dev/null'
+           cleanupgw
+           
+           main
+           cp $script .
+       fi
+       if [[ ! "$OPT_PLOT_DISABLE" ]]; then
+           _plot
+       fi
+    done
 }
 
 test_end() {
     test_end_called=t
-    trap '' DEBUG
+    exit_ok=
     _run
+    exit_ok=t
 }
 
-exit() {
+_myexit() {
+    code=$?
+    cmd=$BASH_COMMAND
     if [[ ! "$test_end_called" ]]; then
        test_end_called=t
        error "bug in the test script: No test_end called"
     fi
+    if ! test -n "$exit_ok"; then
+       error "FATAL: Command '$cmd' exited with code $code"
+    fi
 }
 
-trap 'exit' EXIT
+trap '_myexit' EXIT